% Just replace the following string with folder path with all PTB data.
% In order to dowload all files with the same web structure you can use
% HTTrack Website Copier http://www.httrack.com/page/2/en/index.html

% This script load files from selected folder, convert them into Matlab
% variables and save them on disk in .mat files.
cartella = 'C:\EEGdatabase\EEGdatabase\www.physionet.org\physiobank\database\ptbdb\';

lista = dir(strcat(cartella,'*.*'));
for k=1:length(lista)
    isdir = lista(k).isdir;
    nome = lista(k).name;
    if isdir==1 && length(strfind(nome,'patient'))>0
        nomecartella=nome;
        id = str2num(strrep(nomecartella,'patient',''));
        disp('ID');
        disp(id);
        nomecompleto = strcat(cartella,nomecartella,'\*.hea');
        listahea = dir(nomecompleto);
        Lh = length(listahea);
        for ii=1:Lh
            try
                nome = listahea(ii).name;
                pos  = strfind(nome,'.hea');
                nome = nome(1:pos-1);
                disp(nome);

                file_da_spostare = strcat(nome,'.hea');
                source = strcat(strcat(cartella,nomecartella,'\',file_da_spostare));
                destination = file_da_spostare;
                copyfile(source,destination);

                file_da_spostare = strcat(nome,'.xyz');
                source = strcat(strcat(cartella,nomecartella,'\',file_da_spostare));
                destination = file_da_spostare;
                copyfile(source,destination);

                file_da_spostare = strcat(nome,'.dat');
                source = strcat(strcat(cartella,nomecartella,'\',file_da_spostare));
                destination = file_da_spostare;
                copyfile(source,destination);

                ECGSignal = rdsamp(nome);
                nome_file_mat = strcat('Patient',num2str(id),'_',nome,'.mat');

                save(nome_file_mat,'ECGSignal')
                disp(nome_file_mat);
                pause(0.2);
                
                file_da_cancellare = strcat(nome,'.hea');
                delete(file_da_cancellare);
                file_da_cancellare = strcat(nome,'.xyz');
                delete(file_da_cancellare);
                file_da_cancellare = strcat(nome,'.dat');
                delete(file_da_cancellare);
            catch
                continue;
            end
        end
        %pause;clc;
    end
end